<?php
namespace Cylancer\Usertools\Controller;


use TYPO3\CMS\Extbase\Persistence\QueryInterface;


/***
 *
 * This file is part of the "Event Planner" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2019 Clemens Gogolin
 *           Clemens Gogolin <service@cylancer.net>
 *
 ***/
/**
 * EventController
 */
 
 
class ListController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController
{

   /**
     * userRepository
     * 
     * @TYPO3\CMS\Extbase\Annotation\Inject
     * @var \Cylancer\Usertools\Domain\Repository\UserRepository
     */
    public $userRepository = null;

  
    /**
     * feUserUtility
     * 
     * @TYPO3\CMS\Extbase\Annotation\Inject
     * @var \Cylancer\Usertools\Utility\FeUserUtility
     */
    public $feUserUtility = null;

  

 
  	
    /**
     * action register
     * 
     * @return void
     */
    public function listAllAction()
    {
			$fur = $this->userRepository;
			$fur->setDefaultOrderings([
				'last_name' => QueryInterface::ORDER_ASCENDING, 
				'first_name' => QueryInterface::ORDER_ASCENDING, 
			]);
			$users = $fur->findAll();
			$this->view->assign('users', $users);
		  //debug($users);
		  $nsaGroupFound = false;
		  if($this->feUserUtility->isLogged()){
				$nsaGroup = $this->settings['nsaGroup'];
				$u = $fur->findByUid($this->feUserUtility->getCurrentUserUid());
				
				foreach($u->getUserGroup() AS $ug ){
					if($ug->getUid() == $nsaGroup) {
						$nsaGroupFound = true;
					}
				}
			}
			$this->view->assign('isNSA', $nsaGroupFound);			
    }
    
  
  
    
    
}
