<?php
namespace Cylancer\Usertools\Domain\Model;

use TYPO3\CMS\Extbase\Domain\Model\FrontendUser;

/***
 *
 * This file is part of the "User tools" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2019 Clemens Gogolin <service@cylancer.net>
 *           Clemens Gogolin <service@cylancer.net>
 *
 ***/
/**
 * User
 */
class User extends FrontendUser
{

    /**
     * allowDisplayEmail
     * 
     * @var bool
     */
    protected $allowDisplayEmail = false;

    /**
     * allowDisplayImageInternal
     * 
     * @var bool
     */
    protected $allowDisplayImageInternal = false;

    /**
     * allowDisplayImagePublic
     * 
     * @var bool
     */
    protected $allowDisplayImagePublic = false;

    /**
     * newEmail
     * 
     * @var string
     */
    protected $newEmail = '';

    /**
     * newEmailToken
     * 
     * @var string
     */
    protected $newEmailToken = '';

    /**
     * passwordToken
     * 
     * @var string
     */
    protected $passwordToken = '';

    /**
     * allowDisplayPhone
     * 
     * @var bool
     */
    protected $allowDisplayPhone = false;

    /**
     * picture
     * 
     * @var \TYPO3\CMS\Extbase\Domain\Model\FileReference
     */
    protected $picture = null;


    /**
     * Returns the allowDisplayEmail
     * 
     * @return bool $allowDisplayEmail
     */
    public function getAllowDisplayEmail()
    {
        return $this->allowDisplayEmail;
    }

    /**
     * Sets the allowDisplayEmail
     * 
     * @param bool $allowDisplayEmail
     * @return void
     */
    public function setAllowDisplayEmail($allowDisplayEmail)
    {
        $this->allowDisplayEmail = $allowDisplayEmail;
    }

    /**
     * Returns the boolean state of allowDisplayEmail
     * 
     * @return bool
     */
    public function isAllowDisplayEmail()
    {
        return $this->allowDisplayEmail;
    }

    /**
     * Returns the allowDisplayImageInternal
     * 
     * @return bool allowDisplayImageInternal
     */
    public function getAllowDisplayImageInternal()
    {
        return $this->allowDisplayImageInternal;
    }

    /**
     * Sets the allowDisplayImageInternal
     * 
     * @param bool $allowDisplayImageInternal
     * @return void
     */
    public function setAllowDisplayImageInternal($allowDisplayImageInternal)
    {
        $this->allowDisplayImageInternal = $allowDisplayImageInternal;
    }

    /**
     * Returns the boolean state of allowDisplayImageInternal
     * 
     * @return bool allowDisplayImageInternal
     */
    public function isAllowDisplayImageInternal()
    {
        return $this->allowDisplayImageInternal;
    }

    /**
     * Returns the allowDisplayImagePublic
     * 
     * @return bool $allowDisplayImagePublic
     */
    public function getAllowDisplayImagePublic()
    {
        return $this->allowDisplayImagePublic;
    }

    /**
     * Sets the allowDisplayImagePublic
     * 
     * @param bool $allowDisplayImagePublic
     * @return void
     */
    public function setAllowDisplayImagePublic($allowDisplayImagePublic)
    {
        $this->allowDisplayImagePublic = $allowDisplayImagePublic;
    }

    /**
     * Returns the boolean state of allowDisplayImagePublic
     * 
     * @return bool
     */
    public function isAllowDisplayImagePublic()
    {
        return $this->allowDisplayImagePublic;
    }

    /**
     * Returns the picture
     * 
     * @return \TYPO3\CMS\Extbase\Domain\Model\FileReference $picture
     */
    public function getPicture()
    {
        return $this->picture;
    }

    /**
     * Sets the picture
     * 
     * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $picture
     * @return void
     */
    public function setPicture(\TYPO3\CMS\Extbase\Domain\Model\FileReference $picture = null)
    {
        $this->picture = $picture;
    }

    /**
     * Returns the newEmail
     * 
     * @return string $newEmail
     */
    public function getNewEmail()
    {
        return $this->newEmail;
    }

    /**
     * Sets the newEmail
     * 
     * @param string $newEmail
     * @return void
     */
    public function setNewEmail($newEmail)
    {
        $this->newEmail = $newEmail;
    }

    /**
     * Returns the newEmailToken
     * 
     * @return string $newEmailToken
     */
    public function getNewEmailToken()
    {
        return $this->newEmailToken;
    }

    /**
     * Sets the newEmailToken
     * 
     * @param string $newEmailToken
     * @return void
     */
    public function setNewEmailToken($newEmailToken)
    {
        $this->newEmailToken = $newEmailToken;
    }

    /**
     * Returns the passwordToken
     * 
     * @return string $passwordToken
     */
    public function getPasswordToken()
    {
        return $this->passwordToken;
    }

    /**
     * Sets the newEmailToken
     * 
     * @param string $newEmailToken
     * @return void
     */
    public function setPasswordToken($passwordToken)
    {
        $this->passwordToken = $passwordToken;
    }

    /**
     * Returns the allowDisplayPhone
     * 
     * @return bool $allowDisplayPhone
     */
    public function getAllowDisplayPhone()
    {
        return $this->allowDisplayPhone;
    }

    /**
     * Sets the allowDisplayPhone
     * 
     * @param bool $allowDisplayPhone
     * @return void
     */
    public function setAllowDisplayPhone($allowDisplayPhone)
    {
        $this->allowDisplayPhone = $allowDisplayPhone;
    }

    /**
     * Returns the boolean state of allowDisplayPhone
     * 
     * @return bool
     */
    public function isAllowDisplayPhone()
    {
        return $this->allowDisplayPhone;
    }
}
