<?php
namespace Cylancer\Usertools\Utility;

use TYPO3\CMS\Core\SingletonInterface;
use Cylancer\Usertools\Domain\Model\User;

/**
 * *
 *
 * This file is part of the "Participants" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * (c) 2020 C. Gogolin <service@cylancer.net>
 * C. Gogolin <service@cylancer.net>
 *
 * *
 */
/**
 * The repository for Commitments
 */
class FeUserUtility implements SingletonInterface
{

    /**
     * userRepository
     *
     * @TYPO3\CMS\Extbase\Annotation\Inject
     * @var \Cylancer\Usertools\Domain\Repository\UserRepository
     */
    public $userRepository = null;

    /**
     *
     * @return User Returns the current frontend user
     */
    public function getCurrentUser()
    {
        if (! $this->isLogged()) {
            return false;
        }
        return $this->userRepository->findByUid(FeUserUtility::getCurrentUserUid());
    }

    public function getCurrentUserUid()
    {
        if (! $this->isLogged()) {
            return false;
        }
        $context = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Context\Context::class);
        return $context->getPropertyFromAspect('frontend.user', 'id');
    }

    /**
     * Check if the user is logged
     *
     * @return bool
     */
    public function isLogged()
    {
        $context = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Context\Context::class);
        return $context->getPropertyFromAspect('frontend.user', 'isLoggedIn');
    }
}
