<?php
defined('TYPO3_MODE') || die('Access denied.');

call_user_func(
    function()
    {

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'Cylancer.Usertools',
            'Login',
            [
                'Login' => 'login, doLogin, redirectToSuccessPage, forgottenPassword, sendForgottenPasswordToken, changeForgottenPassword, doChangeForgottenPassword'
            ],
            // non-cacheable actions
            [
               'Login' => 'login, doLogin, redirectToSuccessPage, forgottenPassword, sendForgottenPasswordToken, changeForgottenPassword, doChangeForgottenPassword'
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'Cylancer.Usertools',
            'Editprofile',
            [
                'Profile' => 'editProfile, doEditProfile, deleteUserPicture'
            ],
            // non-cacheable actions
            [
                'Profile' => 'editProfile, doEditProfile, deleteUserPicture'
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'Cylancer.Usertools',
            'Listusers',
            [
                'List' => 'listAll'
            ],
            // non-cacheable actions
            [
                'List' => 'listAll'
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'Cylancer.Usertools',
            'Changeemailform',
            [
                'Profile' => 'changeEmailForm, prepareEmailChange, changeEmail'
            ],
            // non-cacheable actions
            [
                'Profile' => 'changeEmailForm, prepareEmailChange, changeEmail'
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'Cylancer.Usertools',
            'Confirmnewemail',
            [
                'Profile' => 'confirmNewEmail'
            ],
            // non-cacheable actions
            [
                 'Profile' => 'confirmNewEmail'
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'Cylancer.Usertools',
            'Changeuserpassword',
            [
                'Profile' => 'changePasswordForm, changePassword'
            ],
            // non-cacheable actions
            [
                'Profile' => 'changePasswordForm, changePassword'
            ]
        );

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'Cylancer.Usertools',
            'Logout',
            [
                'Login' => 'logout'
            ],
            // non-cacheable actions
            [
                
            ]
        );

    // wizards
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPageTSConfig(
        'mod {
            wizards.newContentElement.wizardItems.plugins {
                elements {
                    login {
                        iconIdentifier = usertools-plugin-login
                        title = LLL:EXT:usertools/Resources/Private/Language/locallang_db.xlf:tx_usertools_login.name
                        description = LLL:EXT:usertools/Resources/Private/Language/locallang_db.xlf:tx_usertools_login.description
                        tt_content_defValues {
                            CType = list
                            list_type = usertools_login
                        }
                    }
                    editprofile {
                        iconIdentifier = usertools-plugin-editprofile
                        title = LLL:EXT:usertools/Resources/Private/Language/locallang_db.xlf:tx_usertools_editprofile.name
                        description = LLL:EXT:usertools/Resources/Private/Language/locallang_db.xlf:tx_usertools_editprofile.description
                        tt_content_defValues {
                            CType = list
                            list_type = usertools_editprofile
                        }
                    }
                    listusers {
                        iconIdentifier = usertools-plugin-listusers
                        title = LLL:EXT:usertools/Resources/Private/Language/locallang_db.xlf:tx_usertools_listusers.name
                        description = LLL:EXT:usertools/Resources/Private/Language/locallang_db.xlf:tx_usertools_listusers.description
                        tt_content_defValues {
                            CType = list
                            list_type = usertools_listusers
                        }
                    }
                    changeemailform {
                        iconIdentifier = usertools-plugin-changeemailform
                        title = LLL:EXT:usertools/Resources/Private/Language/locallang_db.xlf:tx_usertools_changeemailform.name
                        description = LLL:EXT:usertools/Resources/Private/Language/locallang_db.xlf:tx_usertools_changeemailform.description
                        tt_content_defValues {
                            CType = list
                            list_type = usertools_changeemailform
                        }
                    }
                    confirmnewemail {
                        iconIdentifier = usertools-plugin-confirmnewemail
                        title = LLL:EXT:usertools/Resources/Private/Language/locallang_db.xlf:tx_usertools_confirmnewemail.name
                        description = LLL:EXT:usertools/Resources/Private/Language/locallang_db.xlf:tx_usertools_confirmnewemail.description
                        tt_content_defValues {
                            CType = list
                            list_type = usertools_confirmnewemail
                        }
                    }
                    changeuserpassword {
                        iconIdentifier = usertools-plugin-changeuserpassword
                        title = LLL:EXT:usertools/Resources/Private/Language/locallang_db.xlf:tx_usertools_changeuserpassword.name
                        description = LLL:EXT:usertools/Resources/Private/Language/locallang_db.xlf:tx_usertools_changeuserpassword.description
                        tt_content_defValues {
                            CType = list
                            list_type = usertools_changeuserpassword
                        }
                    }
                    logout {
                        iconIdentifier = usertools-plugin-logout
                        title = LLL:EXT:usertools/Resources/Private/Language/locallang_db.xlf:tx_usertools_logout.name
                        description = LLL:EXT:usertools/Resources/Private/Language/locallang_db.xlf:tx_usertools_logout.description
                        tt_content_defValues {
                            CType = list
                            list_type = usertools_logout
                        }
                    }
                }
                show = *
            }
       }'
    );
		$iconRegistry = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Imaging\IconRegistry::class);
		
			$iconRegistry->registerIcon(
				'usertools-plugin-login',
				\TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class,
				['source' => 'EXT:usertools/Resources/Public/Icons/user_plugin_login.svg']
			);
		
			$iconRegistry->registerIcon(
				'usertools-plugin-editprofile',
				\TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class,
				['source' => 'EXT:usertools/Resources/Public/Icons/user_plugin_editprofile.svg']
			);
		
			$iconRegistry->registerIcon(
				'usertools-plugin-listusers',
				\TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class,
				['source' => 'EXT:usertools/Resources/Public/Icons/user_plugin_listusers.svg']
			);
		
			$iconRegistry->registerIcon(
				'usertools-plugin-changeemailform',
				\TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class,
				['source' => 'EXT:usertools/Resources/Public/Icons/user_plugin_changeemailform.svg']
			);
		
			$iconRegistry->registerIcon(
				'usertools-plugin-confirmnewemail',
				\TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class,
				['source' => 'EXT:usertools/Resources/Public/Icons/user_plugin_confirmnewemail.svg']
			);
		
			$iconRegistry->registerIcon(
				'usertools-plugin-changeuserpassword',
				\TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class,
				['source' => 'EXT:usertools/Resources/Public/Icons/user_plugin_changeuserpassword.svg']
			);
		
			$iconRegistry->registerIcon(
				'usertools-plugin-logout',
				\TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class,
				['source' => 'EXT:usertools/Resources/Public/Icons/user_plugin_logout.svg']
			);
		
    }
);


\TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerTypeConverter('Cylancer\\Usertools\\Property\\TypeConverter\\UploadedFileReferenceConverter');


$GLOBALS['TYPO3_CONF_VARS']['SYS']['Objects'][TYPO3\CMS\Frontend\Authentication\FrontendUserAuthentication::class] = [
   'className' =>  Cylancer\Usertools\XClass\CyFrontendUserAuthentication::class
];



